/*
 * serial.h
 *
 * Created: 2017-07-17 00:41:25
 *  Author: doom
 */ 


#ifndef SERIAL_H_
#define SERIAL_H_

//----------------------------------------------
#define SERIAL_PORT					PORTD
#define SERIAL_DDR					DDRD
#define SERIAL_PIN					PIND
#define SERIAL_RXD					0		//RXD
#define SERIAL_TXD					1		//TXD

//----------------------------------------------
#define SERIAL_WBUFFER_SIZE			196
#define SERIAL_RBUFFER_SIZE			255

#define SERIAL_IDLE					0
#define SERIAL_READY				3 

#define SERIAL_SENDING				1
#define SERIAL_RECIVEING			2

#define SERIAL_ENTER_CHAR			'\r'

#define SERIAL_BAUD_2400			0
#define SERIAL_BAUD_4800			1
#define SERIAL_BAUD_9600			2
#define SERIAL_BAUD_14400			3
#define SERIAL_BAUD_19200			4
#define SERIAL_BAUD_28800			5
#define SERIAL_BAUD_57600			6
#define SERIAL_BAUD_115200			7

void SerialInit(void);
void SerialBaudSet(uint8_t baud);
void SerialWBufferAddChar(uint8_t data);
uint8_t SerialWBufferAdd(uint8_t *src);
uint8_t SerialWBufferAddLen(uint8_t *src, uint8_t len);

void SerialWBufferAddVal(int16_t val);
void SerialWBufferAddHexVal(int16_t val);
uint8_t SerialVal2Hex(uint8_t val);
void SerialDebug(uint8_t* src, int16_t val);

void SerialWBufferSend(void);
void SerialWBufferNew(void);
void SerialWBufferQuick(uint8_t *src);

void SerialSendChar(uint8_t data);
void SerialSendMsg(uint8_t *data);
void SerialSendVal(uint16_t value);

uint8_t SerialRBufferCheck(void);
uint8_t SerialRBufferCounter(void);
void SerialRBufferClear(void);
uint8_t SerialRBufferChar(uint8_t index);
uint8_t *SerialRBufferSrc(uint8_t index);

#endif /* SERIAL_H_ */